Unit U_Main;

Interface

Uses
  Classes, Forms, Graphics, Grids, Buttons, StdCtrls, INet, Dialogs, ComCtrls,
  Spin, Menus;

Type
  T_Zeit = 1..60;
  T_Account = 1..10;
  R_Config = record
               Account : Array[1..10] of record
                              update : boolean;
                              Host : string[70];
                              wildcard : boolean;
                              mxhost : string[70];
                              backmx : boolean;
                              proxyserv : string[70];
                              proxyport : integer;
                              debug : boolean;
                              static : boolean;

                         end;
               Zeit : T_Zeit;
               Autostart : boolean;
               Bottom : integer;
               Left : integer;
             end;

Type
  TF_Main = Class (TForm)
    Stg_Account: TStringGrid;
    Cb_Host_1: TCheckBox;
    Cb_Host_2: TCheckBox;
    Cb_Host_3: TCheckBox;
    Cb_Host_4: TCheckBox;
    Cb_Host_5: TCheckBox;
    Cb_Host_6: TCheckBox;
    Cb_Host_7: TCheckBox;
    Cb_Host_8: TCheckBox;
    Cb_Host_9: TCheckBox;
    Cb_Host_10: TCheckBox;
    L_Update: TLabel;
    B_Stop: TButton;
    B_Start: TButton;
    Sp_Intervall: TSpinEdit;
    tcp: TTCP;
    Timer: TTimer;
    MainMenu1: TMainMenu;
    M_Exit: TMenuItem;
    M_About: TMenuItem;
    CB_UpdateStart: TCheckBox;
    Label1: TLabel;

    Procedure Timer_Start (Sender: TObject);
    Procedure About (Sender: TObject);
    Procedure Timer_Stop (Sender: TObject);
    Procedure Start_Update (Sender: TObject);
    Procedure reLoad (Sender: TObject);
    Procedure Account_Configuration (Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X: LongInt; Y: LongInt);
    Procedure ende (Sender: TObject; Var Action: TCloseAction);
    Procedure start (Sender: TObject);
  Private
    {Insert private declarations here}
    procedure Exec_Update(AccountNummer:T_Account);
  Public
    {Insert public declarations here}
  End;

Var
  F_Main: TF_Main;
  DDUP_CONFIG_FILE : BOOLEAN;
  FrontEnd_Config : Boolean;
  Intervall : integer;
  Config : R_Config;
  Xzelle, YZelle : Integer;
  IP_Nummer : String;
  LocalIP : String;

const
  CFG_File = 'ddup_frontend.cfg';

Implementation

USES
  dos, filectrl, sysutils, U_Config, U_About;


Procedure TF_Main.About (Sender: TObject);
Begin
  F_About.show;
End;

Procedure TF_Main.Timer_Stop (Sender: TObject);
Begin
  if (Cb_Host_1.Checked) then
    Stg_Account.Cells[1,1] := 'Stop Update';
  if (Cb_Host_2.Checked) then
    Stg_Account.Cells[1,2] := 'Stop Update';
  if (Cb_Host_3.Checked) then
    Stg_Account.Cells[1,3] := 'Stop Update';
  if (Cb_Host_4.Checked) then
    Stg_Account.Cells[1,4] := 'Stop Update';
  if (Cb_Host_5.Checked) then
    Stg_Account.Cells[1,5] := 'Stop Update';
  if (Cb_Host_6.Checked) then
    Stg_Account.Cells[1,6] := 'Stop Update';
  if (Cb_Host_7.Checked) then
    Stg_Account.Cells[1,7] := 'Stop Update';
  if (Cb_Host_8.Checked) then
    Stg_Account.Cells[1,8] := 'Stop Update';
  if (Cb_Host_9.Checked) then
    Stg_Account.Cells[1,9] := 'Stop Update';
  if (Cb_Host_10.Checked) then
    Stg_Account.Cells[1,10] := 'Stop Update';
  reload(F_Main);
  Stg_Account.Refresh;
  Timer.Stop;
  intervall := 0;
End;

Procedure TF_Main.Timer_Start (Sender: TObject);
Begin
  inc(intervall);
  if (intervall = Config.Zeit) then
  begin
    if (IP_Nummer <> tcp.localIP) then
    begin
       if (Cb_Host_1.Checked) then
         exec_update(1);
       if (Cb_Host_2.Checked) then
         exec_update(2);
       if (Cb_Host_3.Checked) then
         exec_update(3);
       if (Cb_Host_4.Checked) then
         exec_update(4);
       if (Cb_Host_5.Checked) then
         exec_update(5);
       if (Cb_Host_6.Checked) then
         exec_update(6);
       if (Cb_Host_7.Checked) then
         exec_update(7);
       if (Cb_Host_8.Checked) then
         exec_update(8);
       if (Cb_Host_9.Checked) then
         exec_update(9);
       if (Cb_Host_10.Checked) then
         exec_update(10);
       ip_Nummer := tcp.LocalIP;
    end;
    intervall := 0;
  end;
End;

//Update Starten
Procedure TF_Main.Start_Update (Sender: TObject);
Begin
  if (Cb_Host_1.Checked) then
    Stg_Account.Cells[1,1] := 'Start Update';
  if (Cb_Host_2.Checked) then
    Stg_Account.Cells[1,2] := 'Start Update';
  if (Cb_Host_3.Checked) then
    Stg_Account.Cells[1,3] := 'Start Update';
  if (Cb_Host_4.Checked) then
    Stg_Account.Cells[1,4] := 'Start Update';
  if (Cb_Host_5.Checked) then
    Stg_Account.Cells[1,5] := 'Start Update';
  if (Cb_Host_6.Checked) then
    Stg_Account.Cells[1,6] := 'Start Update';
  if (Cb_Host_7.Checked) then
    Stg_Account.Cells[1,7] := 'Start Update';
  if (Cb_Host_8.Checked) then
    Stg_Account.Cells[1,8] := 'Start Update';
  if (Cb_Host_9.Checked) then
    Stg_Account.Cells[1,9] := 'Start Update';
  if (Cb_Host_10.Checked) then
    Stg_Account.Cells[1,10] := 'Start Update';
  IP_Nummer := tcp.localip;
  if (Cb_Host_1.Checked) then
    exec_update(1);
  if (Cb_Host_2.Checked) then
    exec_update(2);
  if (Cb_Host_3.Checked) then
    exec_update(3);
  if (Cb_Host_4.Checked) then
    exec_update(4);
  if (Cb_Host_5.Checked) then
    exec_update(5);
  if (Cb_Host_6.Checked) then
    exec_update(6);
  if (Cb_Host_7.Checked) then
    exec_update(7);
  if (Cb_Host_8.Checked) then
    exec_update(8);
  if (Cb_Host_9.Checked) then
    exec_update(9);
  if (Cb_Host_10.Checked) then
    exec_update(10);
  Stg_Account.refresh;
  Timer.start;
End;

//Beim Aktivieren des Haupt Fensters
Procedure TF_Main.reLoad (Sender: TObject);
var i : 1..10;
Begin
  if (FrontEnd_Config) then
  begin
     for i:=1 to 9 do
     begin
       Stg_Account.Cells[0,i] := config.Account[i].host;
     End;
     Stg_Account.Refresh;
  End;
End;


//Beim Klicken auf die Account Liste
Procedure TF_Main.Account_Configuration (Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X: LongInt; Y: LongInt);
Begin
  XZelle := Stg_Account.Col;
  YZelle := Stg_Account.Row;
  F_Config.show;
End;

procedure TF_Main.ende (Sender: TObject; Var Action: TCloseAction);
var datei : file of r_config;
begin
  timer.stop;
  Config.Autostart := CB_UpdateStart.checked;
  Config.Bottom := Bottom;
  Config.Left := Left;
  Config.Zeit := Sp_Intervall.Value;
  Config.Account[1].update := Cb_Host_1.checked;
  Config.Account[2].update := Cb_Host_2.checked;
  Config.Account[3].update := Cb_Host_3.checked;
  Config.Account[4].update := Cb_Host_4.checked;
  Config.Account[5].update := Cb_Host_5.checked;
  Config.Account[6].update := Cb_Host_6.checked;
  Config.Account[7].update := Cb_Host_7.checked;
  Config.Account[8].update := Cb_Host_8.checked;
  Config.Account[9].update := Cb_Host_9.checked;
  Config.Account[10].update := Cb_Host_10.checked;
  assignfile(datei,CFG_File);
  try
    rewrite(datei);
    write(datei,config);
  finally
    closefile(datei);
  end;
End;

Procedure TF_Main.start (Sender: TObject);
var Datei: file of R_Config;
Begin
  //Caption := 'DDUP Frontend $Revision: 1.1.1.1 $';
  FrontEnd_Config := false;
  if ( fileexists('ddup.conf') ) then
  begin
    if ( fileexists(CFG_File) ) then
    begin
      assignfile(Datei,CFG_File);
      try
        reset(Datei);
        read(Datei,Config);
      finally
        closefile(Datei);
      end;
    end;
    CB_UpdateStart.checked := config.Autostart;
    LocalIP := tcp.LocalIP;
    Intervall := 0;
    FrontEnd_Config := true;
    Sp_Intervall.Value := Config.Zeit;
    Bottom := Config.Bottom;
    Left := Config.Left;
    if (Config.Account[1].update) then
    begin
       Stg_Account.Cells[1,1] := 'Local IP: '+localIP;
       Cb_Host_1.checked := true;
    end;
    if (Config.Account[2].update) then
    begin
       Stg_Account.Cells[1,2] := 'Local IP: '+localIP;
       Cb_Host_2.checked := true;
    end;
    if (Config.Account[3].update) then
    begin
       Stg_Account.Cells[1,3] := 'Local IP: '+localIP;
       Cb_Host_3.checked := true;
    end;
    if (Config.Account[4].update) then
    begin
       Stg_Account.Cells[1,4] := 'Local IP: '+localIP;
       Cb_Host_4.checked := true;
    end;
    if (Config.Account[5].update) then
    begin
       Stg_Account.Cells[1,5] := 'Local IP: '+localIP;
       Cb_Host_5.checked := true;
    end;
    if (Config.Account[6].update) then
    begin
       Stg_Account.Cells[1,6] := 'Local IP: '+localIP;
       Cb_Host_6.checked := true;
    end;
    if (Config.Account[7].update) then
    begin
       Stg_Account.Cells[1,7] := 'Local IP: '+localIP;
       Cb_Host_7.checked := true;
    end;
    if (Config.Account[8].update) then
    begin
       Stg_Account.Cells[1,8] := 'Local IP: '+localIP;
       Cb_Host_8.checked := true;
    end;
    if (Config.Account[9].update) then
    begin
       Stg_Account.Cells[1,9] := 'Local IP: '+localIP;
       Cb_Host_9.checked := true;
    end;
    if (Config.Account[10].update) then
    begin
       Stg_Account.Cells[1,10] := 'Local IP: '+localIP;
       Cb_Host_10.checked := true;
    end;
    reload(F_Main);
  end
  else
    DDUP_Config_file := false;
  stg_account.cells[0,0] := 'Host';
  Stg_Account.Cells[1,0] := 'Status';
  if (Config.Autostart) then
    start_update(F_Main);
End;

//Updaten
Procedure TF_Main.Exec_Update(AccountNummer:T_Account);
var DName : string[10];
    i : 1..10;
    cmd : string;
    Datei : textfile;
begin
     i := AccountNummer;
     DName := 'DDUP.EXE';
     if (FrontEnd_Config) then
     begin
       cmd := '--host '+Config.Account[i].host;
       if (Config.Account[i].mxhost <> '') then
         cmd := cmd+' --mxhost '+Config.Account[i].mxhost;
       if (Config.Account[i].backmx) then
         cmd := cmd+' --backmx';
       if (Config.Account[i].proxyserv <> '') then
         cmd := cmd+' --proxyserv '+Config.Account[i].proxyserv;
       if (Config.Account[i].proxyport > 0) then
         cmd := cmd+' --poxyport '+toStr(Config.Account[i].proxyport);
       if (Config.Account[i].debug) then
         cmd := cmd+' --debug ';
       if (Config.Account[i].static) then
         cmd := cmd+' --static ';
       Stg_Account.cells[1,i] := timeToStr(time)+ ' Update New IP: '+tcp.LocalIP;
       Stg_Account.Refresh;

       //Assignfile(Datei,);
       //rewrite(datei);
       //writeln(datei,cmd);
       //closefile(datei);

       ExecViaSession:=false;
       AsynchExec:=false;
       UpcaseStr(DName);
       Exec(DName,Cmd);
       IF DosError IN[396,418,460,463] Then ErrorBox('Error!!!');
     end;
end;


Initialization
  RegisterClasses ([TF_Main, TStringGrid, TCheckBox, TLabel, TTCP, TTimer
   , TButton, TSpinEdit, TMainMenu, TMenuItem]);
End.
